;-- TIME_STAMP   2017-05-14 15:39:24   v 0.1

#Region    ;************ Includes ************
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <Array.au3>
#include "ImageSearch.au3"
#include <WinAPI.au3>
#EndRegion ;************ Includes ************

Global $g_sGIF = @ScriptDir & "\FireFox.gif"
Global $g_sBMP = @ScriptDir & "\FireFox.bmp"
Global $g_sICO = @ScriptDir & "\FireFox.ico"

Global $g_hGUI, $g_aRegion[4], $g_iCheckSum1, $g_iCheckSum2, $g_aMousePos

#cs
	Beim ersten Start wird das Firefox-Icon auf den Desktop kopiert.
	Danach musst du noch zwei Dinge selbst erledigen, damit es funktioniert.

	1.) Position des Firefox-Icons auf dem Desktop wie im Bild gezeigt anpassen
	2.) $g_aRegion[0] und $g_aRegion[1] evtl. korrigieren
#ce

; Desktop nach vorne holen
WinMinimizeAll()

OnAutoItExitRegister('_Exit')

Example()

Func Example()
	; Firefox-Icon auf den Desktop kopieren
	If Not FileExists(@DesktopDir & '\FireFox.ico') Then FileCopy(@ScriptDir & "\FireFox.ico", @DesktopDir)

    $g_hGUI = GUICreate("_ImageSearch_Demo", 350, 350, 800, 300, $WS_SIZEBOX + $WS_SYSMENU) ; will create a dialog box that when displayed is centered

    GUISetBkColor(0xE0FFFF)
    Local $idLabel_Info = GUICtrlCreateLabel('Wenn du jetzt mit der Maus ber das Icon fhrst, lst du damit ein _ImageSearch() aus!', 50, 275, 256, 50)
	GUICtrlSetState($idLabel_Info, $GUI_HIDE)
	GUICtrlSetColor($idLabel_Info, 0xFF0000)
    GUISetState(@SW_SHOW)


    Local $idPic = GUICtrlCreateIcon($g_sICO, 1, 50, 10, 256, 256)

	; Muss an die Position des FireFox-Icons auf dem Desktop angepasst werden!!!
	$g_aRegion[0] = 272	; X-Offset					($g_sICO)
	$g_aRegion[1] = 8	; Y-Offset					($g_sICO)
	$g_aRegion[2] = 43	; Breite der Suchmaske		($g_sGIF / $g_sBMP)
	$g_aRegion[3] = 43	; Hhe der der Suchmaske	($g_sGIF / $g_sBMP)

;~ 	_ArrayDisplay($g_aRegion, '$g_aRegion')
	ConsoleWrite('$g_aRegion = ' & _ArrayToString($g_aRegion, ', ') & @CRLF)

	AdlibRegister('_GetMousePos')
	AdlibRegister('_ToolTip')

	MouseMove($g_aRegion[0], $g_aRegion[1], 25)
	Sleep(300)
	MouseMove($g_aMousePos[0] + $g_aRegion[2], $g_aMousePos[1], 25); rechts
	Sleep(300)
	MouseMove($g_aMousePos[0], $g_aMousePos[1] + $g_aRegion[3], 25); runter
	Sleep(300)
	MouseMove($g_aMousePos[0] - $g_aRegion[2], $g_aMousePos[1], 25); links
	Sleep(300)
	MouseMove($g_aMousePos[0], $g_aMousePos[1] - $g_aRegion[3], 25); hoch
	Sleep(1000)
	MouseMove($g_aMousePos[0] + $g_aRegion[2] * 2, $g_aMousePos[1] + $g_aRegion[3] * 2)
	Sleep(300)

	GUICtrlSetState($idLabel_Info, $GUI_SHOW)

	$g_iCheckSum1 = PixelChecksum($g_aRegion[0], $g_aRegion[1], $g_aRegion[2], $g_aRegion[3])
	ConsoleWrite('$g_iCheckSum1 = 0x' & Hex($g_iCheckSum1, 8) & @CRLF)

	AdlibRegister('_Check')

    ; Loop until the user exits.
    While 1
        Switch GUIGetMsg()
            Case $GUI_EVENT_CLOSE
                ExitLoop
        EndSwitch
    WEnd

    GUIDelete()
	Exit
EndFunc   ;==>Example

Func _Check()
	Local Static $resultPosition = 1, $x = $g_aRegion[0] + $g_aRegion[2] / 2, $y = $g_aRegion[1] + $g_aRegion[2] / 2, $tolerance = 20

	$g_iCheckSum2 = PixelChecksum($g_aRegion[0], $g_aRegion[1], $g_aRegion[2], $g_aRegion[3])
	If $g_iCheckSum1 = $g_iCheckSum2 Then Return

	ConsoleWrite('$g_iCheckSum2 = 0x' & Hex($g_iCheckSum2, 8) & @CRLF)

	AdlibUnRegister('_Check')
	AdlibUnRegister('_ToolTip')
	AdlibUnRegister('_GetMousePos')
	ToolTip('')
	MsgBox(64, 'Achtung', 'Es hat sich was gendert!')

;~ Du wahlweise das BMP oder GIF als Suchmaske verwenden... funktioniert beides, mit BMP geht es aber logischerweise schneller!
;~ 	Local $iSearch = _ImageSearch($g_sBMP, $resultPosition, $x, $y, $tolerance)
	Local $iSearch = _ImageSearch($g_sGIF, $resultPosition, $x, $y, $tolerance)
	ConsoleWrite('$iSearch = ' & $iSearch & @CRLF)
	If $iSearch = 0 Then
		$g_iCheckSum2 = -1
		AdlibRegister('_GetMousePos')
		AdlibRegister('_ToolTip')
		AdlibRegister('_Check')
	Else
		MsgBox(64, 'Vorsicht', '>>>>>>>>> Aufpassen <<<<<<<<<')
		Exit
	EndIf
EndFunc

Func _GetMousePos()
	$g_aMousePos = MouseGetPos()
EndFunc

Func _ToolTip()
	ToolTip($g_aMousePos[0] & ', ' & $g_aMousePos[1] & @CRLF & _
		'$g_iCheckSum1(0x' & Hex(0, 8) & ') = $g_iCheckSum2(0x' & Hex($g_iCheckSum2, 8) & ')', _
		$g_aMousePos[0] +50, $g_aMousePos[1] +50)
EndFunc

Func _Exit()
	WinMinimizeAllUndo()
EndFunc
